import sys
sys.path.append('../zerosumset')
import pytest


from zerosumset import zerosumset

test_cases_identical = [[], [1, 2, -3], [0]]

@pytest.mark.parametrize("elems", test_cases_identical)
def test_zerosumset(elems):
    output = zerosumset(elems)
    assert output == elems, f"Failed: expected {elems}"


from hypothesis import given, strategies as st, event, assume

from random import randint

@st.composite
def gen_solvable(draw, min_size=5, max_size=10):
    xs = draw(st.lists(st.integers(), min_size=5, max_size=10))
    n  = draw(st.integers(min_value=1))
    l  = len(xs)
    pos1 = randint(0, l-1)
    xs.insert(pos1, n)
    pos2 = randint(0, l)
    xs.insert(pos2, -n)
    return xs

@given(gen_solvable())
# @given(st.lists(st.integers(), min_size=5, max_size=10).filter(lambda xs: not all(x > 0 for x in xs)))
def test_sum_is_zero(xs):
    # assume(not all(x > 0 for x in xs))
    subxs = zerosumset(xs)
    if not subxs: event("null result")
    assert sum(subxs) == 0, f"Result doesn't have zero sum: {subxs}"

